jQuery(document).ready(function($){

	// Test Shared Count API

	$('.' + nnr_as_data.prefix_dash + 'shared-count-test').click(function(e){

		e.preventDefault();

		$(this).append('<i style="margin-left: 10px;" class="fa fa-spinner fa-spin"></i>');
		$('.' + nnr_as_data.prefix_dash + 'shared-count-test').parent().find('em').remove();

		$.post(ajaxurl, {
				'action': 'nnr_as_shared_count_test',
				'api_key': $('.' + nnr_as_data.prefix_dash + 'shared-count-api-key').val(),
			}, function(response) {

			$('.' + nnr_as_data.prefix_dash + 'shared-count-test').find('.fa').remove();

			response = $.parseJSON(response);

			if ( response.status == 'check' ) {
				$('.' + nnr_as_data.prefix_dash + 'shared-count-test').append('<i style="margin-left: 10px;color:green;" class="fa fa-check"></i>');
				$('.' + nnr_as_data.prefix_dash + 'shared-count-test').css('border-color', 'green');
			} else {
				$('.' + nnr_as_data.prefix_dash + 'shared-count-test').append('<i style="margin-left: 10px;color:red;" class="fa fa-warning"></i>');
				$('.' + nnr_as_data.prefix_dash + 'shared-count-test').css('border-color', 'red');
			}

			$('<em class="help-block">' + response.message + '</em>').insertAfter('.' + nnr_as_data.prefix_dash + 'shared-count-test');

		});
	});

	$('.' + nnr_as_data.prefix_dash + 'shared-count-test').append('<i style="margin-left: 10px;" class="fa fa-spinner fa-spin"></i>');

	$.post(ajaxurl, {
			'action': 'nnr_as_shared_count_test',
			'api_key': $('.' + nnr_as_data.prefix_dash + 'shared-count-api-key').val(),
		}, function(response) {

		$('.' + nnr_as_data.prefix_dash + 'shared-count-test').find('.fa').remove();

		response = $.parseJSON(response);

		if ( response.status == 'check' ) {
			$('.' + nnr_as_data.prefix_dash + 'shared-count-test').append('<i style="margin-left: 10px;color:green;" class="fa fa-check"></i>');
			$('.' + nnr_as_data.prefix_dash + 'shared-count-test').css('border-color', 'green');
		} else {
			$('.' + nnr_as_data.prefix_dash + 'shared-count-test').append('<i style="margin-left: 10px;color:red;" class="fa fa-warning"></i>');
			$('.' + nnr_as_data.prefix_dash + 'shared-count-test').css('border-color', 'red');
		}

		$('<em class="help-block">' + response.message + '</em>').insertAfter('.' + nnr_as_data.prefix_dash + 'shared-count-test');

		console.log(response);

	});

	// Define the variables

	var license_activate_button = '<span class="btn btn-primary ' +
		nnr_as_data.prefix_dash + 'activate-license">' +
		nnr_as_data.activate_text + '</span>';

	var license_deactivate_button = '<span class="btn btn-default ' +
		nnr_as_data.prefix_dash + 'deactivate-license">' +
		nnr_as_data.deactivate_text + '</span>';

	var check = '<span class="fa fa-check form-control-feedback" aria-hidden="true"></span>';
	var error = '<span class="fa fa-times form-control-feedback" aria-hidden="true"></span>';
	var spinner = '<i class="' + nnr_as_data.prefix_dash + 'license-key-status fa fa-spinner fa-spin form-control-feedback"></i>';

	// Check license key

	if ( $('.' + nnr_as_data.prefix_dash + 'license-key').val() != '' ) {

		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(spinner);

		var data = {
			'action': 'nnr_as_license_action',
			'license_action': 'check_license',
			'license_key': $('.' + nnr_as_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
			$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
			$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

			if ( response == 'valid' ) {

				$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.activation_valid + '</em>');

			}  else if ( response == 'expired' ) {

				$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.expired + '</em>');

			} else {

				$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.activation_error + '</em>');

			}

			console.log(response);
		});
	} else {
		$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(error);
		$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-error');

		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.no_license_key + '</em>');
	}

	// Activate License

	$(document).on('click', '.' + nnr_as_data.prefix_dash + 'activate-license', function(){

		$('.' + nnr_as_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_as_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_as_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_as_license_action',
			'license_action': 'activate_license',
			'license_key': $('.' + nnr_as_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'valid' ) {

				$('.alert').remove();

				$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.activation_valid + '</em>');

			} else {

				$('.' + nnr_as_data.prefix_dash + 'license-key').addClass(nnr_as_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.activation_error + '</em>');

			}

			console.log(response);
		});

	});

	// Deactivate License

	$(document).on('click', '.' + nnr_as_data.prefix_dash + 'deactivate-license', function(){

		$('.' + nnr_as_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_as_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_as_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_as_license_action',
			'license_action': 'deactivate_license',
			'license_key': $('.' + nnr_as_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'deactivated' ) {

				$('.' + nnr_as_data.prefix_dash + 'license-key').val('');
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				///$('.' + nnr_as_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.deactivation_valid + '</em>');

			} else if ( response == 'failed' ) {

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.deactivation_error + '</em>');

			} else {

				$('.' + nnr_as_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_as_data.prefix_dash + 'activation-message">' + nnr_as_data.deactivation_error + '</em>');
			}

			console.log(response);
		});

	});

});